/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Interface Declarations                                                     *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

namespace mlir {
class TestEffectOpInterface;
namespace detail {
struct TestEffectOpInterfaceInterfaceTraits {
  struct Concept {
    void (*getEffects)(const Concept *impl, ::mlir::Operation *, ::mlir::SmallVectorImpl<::mlir::SideEffects::EffectInstance<::mlir::TestEffects::Effect>> &);
  };
  template<typename ConcreteOp>
  class Model : public Concept {
  public:
    using Interface = ::mlir::TestEffectOpInterface;
    Model() : Concept{getEffects} {}

    static inline void getEffects(const Concept *impl, ::mlir::Operation *tablegen_opaque_val, ::mlir::SmallVectorImpl<::mlir::SideEffects::EffectInstance<::mlir::TestEffects::Effect>> & effects);
  };
  template<typename ConcreteOp>
  class FallbackModel : public Concept {
  public:
    using Interface = ::mlir::TestEffectOpInterface;
    FallbackModel() : Concept{getEffects} {}

    static inline void getEffects(const Concept *impl, ::mlir::Operation *tablegen_opaque_val, ::mlir::SmallVectorImpl<::mlir::SideEffects::EffectInstance<::mlir::TestEffects::Effect>> & effects);
  };
  template<typename ConcreteModel, typename ConcreteOp>
  class ExternalModel : public FallbackModel<ConcreteModel> {
  public:
  };
};template <typename ConcreteOp>
struct TestEffectOpInterfaceTrait;

} // namespace detail
class TestEffectOpInterface : public ::mlir::OpInterface<TestEffectOpInterface, detail::TestEffectOpInterfaceInterfaceTraits> {
public:
  using ::mlir::OpInterface<TestEffectOpInterface, detail::TestEffectOpInterfaceInterfaceTraits>::OpInterface;
  template <typename ConcreteOp>
  struct Trait : public detail::TestEffectOpInterfaceTrait<ConcreteOp> {};
  void getEffects(::mlir::SmallVectorImpl<::mlir::SideEffects::EffectInstance<::mlir::TestEffects::Effect>> & effects);

    /// Collect all of the effect instances that correspond to the given
    /// `Effect` and place them in 'effects'.
    template <typename Effect> void getEffects(
      SmallVectorImpl<::mlir::SideEffects::EffectInstance<
                                              ::mlir::TestEffects::Effect>> &effects) {
      getEffects(effects);
      llvm::erase_if(effects, [&](auto &it) {
        return !llvm::isa<Effect>(it.getEffect());
      });
    }

    /// Returns true if this operation exhibits the given effect.
    template <typename Effect> bool hasEffect() {
      SmallVector<SideEffects::EffectInstance<::mlir::TestEffects::Effect>, 4> effects;
      getEffects(effects);
      return llvm::any_of(effects, [](const auto &it) {
        return llvm::isa<Effect>(it.getEffect());
      });
    }

    /// Returns true if this operation only has the given effect.
    template <typename Effect> bool onlyHasEffect() {
      SmallVector<SideEffects::EffectInstance<::mlir::TestEffects::Effect>, 4> effects;
      getEffects(effects);
      return !effects.empty() && llvm::all_of(effects, [](const auto &it) {
        return isa<Effect>(it.getEffect());
      });
    }

    /// Returns true if this operation has no effects.
    bool hasNoEffect() {
      SmallVector<::mlir::SideEffects::EffectInstance<::mlir::TestEffects::Effect>, 4> effects;
      getEffects(effects);
      return effects.empty();
    }

    /// Returns true if the given operation has no effects for this interface.
    static bool hasNoEffect(Operation *op) {
      if (auto interface = dyn_cast<TestEffectOpInterface>(op))
        return interface.hasNoEffect();
      return op->hasTrait<::mlir::OpTrait::HasRecursiveSideEffects>();
    }

    /// Collect all of the effect instances that operate on the provided value
    /// and place them in 'effects'.
    void getEffectsOnValue(::mlir::Value value,
              llvm::SmallVectorImpl<::mlir::SideEffects::EffectInstance<
              ::mlir::TestEffects::Effect>> & effects) {
      getEffects(effects);
      llvm::erase_if(effects, [&](auto &it) { return it.getValue() != value; });
    }

    /// Return the effect of the given type `Effect` that is applied to the
    /// given value, or None if no effect exists.
    template <typename Effect>
    ::llvm::Optional<::mlir::SideEffects::EffectInstance<::mlir::TestEffects::Effect>>
    getEffectOnValue(::mlir::Value value) {
      llvm::SmallVector<::mlir::SideEffects::EffectInstance<
              ::mlir::TestEffects::Effect>, 4> effects;
      getEffects(effects);
      auto it = llvm::find_if(effects, [&](auto &it) {
        return isa<Effect>(it.getEffect()) && it.getValue() == value;
      });
      if (it == effects.end())
        return llvm::None;
      return *it;
    }

    /// Collect all of the effect instances that operate on the provided symbol
    /// reference and place them in 'effects'.
    void getEffectsOnSymbol(::mlir::SymbolRefAttr value,
              llvm::SmallVectorImpl<::mlir::SideEffects::EffectInstance<
              ::mlir::TestEffects::Effect>> & effects) {
      getEffects(effects);
      llvm::erase_if(effects, [&](auto &it) {
        return it.getSymbolRef() != value;
      });
    }

    /// Collect all of the effect instances that operate on the provided
    /// resource and place them in 'effects'.
    void getEffectsOnResource(::mlir::SideEffects::Resource *resource,
              llvm::SmallVectorImpl<::mlir::SideEffects::EffectInstance<
              ::mlir::TestEffects::Effect>> & effects) {
      getEffects(effects);
      llvm::erase_if(effects, [&](auto &it) {
        return it.getResource() != resource;
      });
    }
  
};
namespace detail {
  template <typename ConcreteOp>
  struct TestEffectOpInterfaceTrait : public ::mlir::OpInterface<TestEffectOpInterface, detail::TestEffectOpInterfaceInterfaceTraits>::Trait<ConcreteOp> {
  };
}// namespace detail
template<typename ConcreteOp>
void detail::TestEffectOpInterfaceInterfaceTraits::Model<ConcreteOp>::getEffects(const Concept *impl, ::mlir::Operation *tablegen_opaque_val, ::mlir::SmallVectorImpl<::mlir::SideEffects::EffectInstance<::mlir::TestEffects::Effect>> & effects) {
  return (llvm::cast<ConcreteOp>(tablegen_opaque_val)).getEffects(effects);
}
template<typename ConcreteOp>
void detail::TestEffectOpInterfaceInterfaceTraits::FallbackModel<ConcreteOp>::getEffects(const Concept *impl, ::mlir::Operation *tablegen_opaque_val, ::mlir::SmallVectorImpl<::mlir::SideEffects::EffectInstance<::mlir::TestEffects::Effect>> & effects) {
  return static_cast<const ConcreteOp *>(impl)->getEffects(tablegen_opaque_val, effects);
}
} // namespace mlir
namespace mlir {
class TestExternalOpInterface;
namespace detail {
struct TestExternalOpInterfaceInterfaceTraits {
  struct Concept {
    unsigned (*getNameLengthPlusArg)(const Concept *impl, ::mlir::Operation *, unsigned);
    unsigned (*getNameLengthPlusArgTwice)(unsigned);
    unsigned (*getNameLengthTimesArg)(const Concept *impl, ::mlir::Operation *, unsigned);
    unsigned (*getNameLengthMinusArg)(unsigned);
  };
  template<typename ConcreteOp>
  class Model : public Concept {
  public:
    using Interface = ::mlir::TestExternalOpInterface;
    Model() : Concept{getNameLengthPlusArg, getNameLengthPlusArgTwice, getNameLengthTimesArg, getNameLengthMinusArg} {}

    static inline unsigned getNameLengthPlusArg(const Concept *impl, ::mlir::Operation *tablegen_opaque_val, unsigned arg);
    static inline unsigned getNameLengthPlusArgTwice(unsigned arg);
    static inline unsigned getNameLengthTimesArg(const Concept *impl, ::mlir::Operation *tablegen_opaque_val, unsigned arg);
    static inline unsigned getNameLengthMinusArg(unsigned arg);
  };
  template<typename ConcreteOp>
  class FallbackModel : public Concept {
  public:
    using Interface = ::mlir::TestExternalOpInterface;
    FallbackModel() : Concept{getNameLengthPlusArg, getNameLengthPlusArgTwice, getNameLengthTimesArg, getNameLengthMinusArg} {}

    static inline unsigned getNameLengthPlusArg(const Concept *impl, ::mlir::Operation *tablegen_opaque_val, unsigned arg);
    static inline unsigned getNameLengthPlusArgTwice(unsigned arg);
    static inline unsigned getNameLengthTimesArg(const Concept *impl, ::mlir::Operation *tablegen_opaque_val, unsigned arg);
    static inline unsigned getNameLengthMinusArg(unsigned arg);
  };
  template<typename ConcreteModel, typename ConcreteOp>
  class ExternalModel : public FallbackModel<ConcreteModel> {
  public:
    unsigned getNameLengthTimesArg(::mlir::Operation *tablegen_opaque_val, unsigned arg) const;
    static unsigned getNameLengthMinusArg(unsigned arg);
  };
};template <typename ConcreteOp>
struct TestExternalOpInterfaceTrait;

} // namespace detail
class TestExternalOpInterface : public ::mlir::OpInterface<TestExternalOpInterface, detail::TestExternalOpInterfaceInterfaceTraits> {
public:
  using ::mlir::OpInterface<TestExternalOpInterface, detail::TestExternalOpInterfaceInterfaceTraits>::OpInterface;
  template <typename ConcreteOp>
  struct Trait : public detail::TestExternalOpInterfaceTrait<ConcreteOp> {};
  unsigned getNameLengthPlusArg(unsigned arg);
  unsigned getNameLengthPlusArgTwice(unsigned arg);
  unsigned getNameLengthTimesArg(unsigned arg);
  unsigned getNameLengthMinusArg(unsigned arg);
};
namespace detail {
  template <typename ConcreteOp>
  struct TestExternalOpInterfaceTrait : public ::mlir::OpInterface<TestExternalOpInterface, detail::TestExternalOpInterfaceInterfaceTraits>::Trait<ConcreteOp> {
    unsigned getNameLengthTimesArg(unsigned arg) {
      return arg * (*static_cast<ConcreteOp *>(this))->getName().getStringRef().size();
    }
    static unsigned getNameLengthMinusArg(unsigned arg) {
      return ConcreteOp::getOperationName().size() - arg;
    }
  };
}// namespace detail
template<typename ConcreteOp>
unsigned detail::TestExternalOpInterfaceInterfaceTraits::Model<ConcreteOp>::getNameLengthPlusArg(const Concept *impl, ::mlir::Operation *tablegen_opaque_val, unsigned arg) {
  return (llvm::cast<ConcreteOp>(tablegen_opaque_val)).getNameLengthPlusArg(arg);
}
template<typename ConcreteOp>
unsigned detail::TestExternalOpInterfaceInterfaceTraits::Model<ConcreteOp>::getNameLengthPlusArgTwice(unsigned arg) {
  return ConcreteOp::getNameLengthPlusArgTwice(arg);
}
template<typename ConcreteOp>
unsigned detail::TestExternalOpInterfaceInterfaceTraits::Model<ConcreteOp>::getNameLengthTimesArg(const Concept *impl, ::mlir::Operation *tablegen_opaque_val, unsigned arg) {
  return (llvm::cast<ConcreteOp>(tablegen_opaque_val)).getNameLengthTimesArg(arg);
}
template<typename ConcreteOp>
unsigned detail::TestExternalOpInterfaceInterfaceTraits::Model<ConcreteOp>::getNameLengthMinusArg(unsigned arg) {
  return ConcreteOp::getNameLengthMinusArg(arg);
}
template<typename ConcreteOp>
unsigned detail::TestExternalOpInterfaceInterfaceTraits::FallbackModel<ConcreteOp>::getNameLengthPlusArg(const Concept *impl, ::mlir::Operation *tablegen_opaque_val, unsigned arg) {
  return static_cast<const ConcreteOp *>(impl)->getNameLengthPlusArg(tablegen_opaque_val, arg);
}
template<typename ConcreteOp>
unsigned detail::TestExternalOpInterfaceInterfaceTraits::FallbackModel<ConcreteOp>::getNameLengthPlusArgTwice(unsigned arg) {
  return ConcreteOp::getNameLengthPlusArgTwice(arg);
}
template<typename ConcreteOp>
unsigned detail::TestExternalOpInterfaceInterfaceTraits::FallbackModel<ConcreteOp>::getNameLengthTimesArg(const Concept *impl, ::mlir::Operation *tablegen_opaque_val, unsigned arg) {
  return static_cast<const ConcreteOp *>(impl)->getNameLengthTimesArg(tablegen_opaque_val, arg);
}
template<typename ConcreteOp>
unsigned detail::TestExternalOpInterfaceInterfaceTraits::FallbackModel<ConcreteOp>::getNameLengthMinusArg(unsigned arg) {
  return ConcreteOp::getNameLengthMinusArg(arg);
}
template<typename ConcreteModel, typename ConcreteOp>
unsigned detail::TestExternalOpInterfaceInterfaceTraits::ExternalModel<ConcreteModel, ConcreteOp>::getNameLengthTimesArg(::mlir::Operation *tablegen_opaque_val, unsigned arg) const {
return arg * (llvm::cast<ConcreteOp>(tablegen_opaque_val))->getName().getStringRef().size();
}
template<typename ConcreteModel, typename ConcreteOp>
unsigned detail::TestExternalOpInterfaceInterfaceTraits::ExternalModel<ConcreteModel, ConcreteOp>::getNameLengthMinusArg(unsigned arg) {
return ConcreteOp::getOperationName().size() - arg;
}
} // namespace mlir
